# -*- coding: utf-8 -*-

import ast
import json

from odoo import http
from odoo.http import request
from ..api.utils import *

token = fetch_token()


class CodeswholesaleOdooIntegration(http.Controller):
    # @http.route('/codeswholesale_odoo_integration/codeswholesale_odoo_integration', auth='public')
    # def index(self, **kw):
    #     fetch_token()
    #     return "Hello, world"

    @http.route('/get/token/', type='http', auth='public', website=True)
    def token(self, **kw):
        return token

    @http.route('/get/platforms/', type='http', auth='public', website=True)
    def plateforms(self, **kw):
        api = CodeWholeSaleAPI(token=token)

        response = api.raw_query(
            endpoint=f'v2/platforms',
            http_method='get',
            data={}
        )
        if response.status_code in (200, 202):
            try:
                platforms = ast.literal_eval(response.content.decode('utf-8'))['platforms']
                for platform in platforms:
                    print(platform)
                    existing_platform = len(http.request.env['cws.platform'].search([('name', '=', platform['name'])]))
                    if existing_platform:
                        continue
                    else:
                        http.request.env['cws.platform'].create({'name': platform['name']})
            except Exception as e:
                print(e.args[0])
                return "Exception"
            return "Created"
        else:
            return "API Failed"

    @http.route('/get/region/', type='http', auth='public', website=True)
    def region(self, **kw):
        api = CodeWholeSaleAPI(token=token)

        response = api.raw_query(
            endpoint=f'v2/regions',
            http_method='get',
            data={}
        )
        if response.status_code in (200, 202):
            try:
                regions = ast.literal_eval(response.content.decode('utf-8'))['regions']
                for region in regions:
                    existing_region = len(http.request.env['cws.region'].search([('name', '=', region['name'])]))
                    if existing_region:
                        continue
                    else:
                        http.request.env['cws.region'].create({'name': region['name']})
            except Exception as e:
                print(e.args[0])
                return "API exception "
            return "Region created"
        else:
            return "API failed"

    @http.route('/get/language/', type='http', auth='public', website=True)
    def language(self, **kw):
        api = CodeWholeSaleAPI(token=token)
        response = api.raw_query(
            endpoint=f'v2/languages',
            http_method='get',
            data={}
        )
        if response.status_code in (200, 202):
            try:
                languages = ast.literal_eval(response.content.decode('utf-8'))['languages']
                for language in languages:
                    existing_language = len(http.request.env['cws.language'].search([('name', '=', language['name'])]))
                    if existing_language:
                        continue
                    else:
                        http.request.env['cws.language'].create({'name': language['name']})
            except Exception as e:
                print(e.args[0])
                return "API exception"
            return "Region created"
        else:
            return "API failed"

    @http.route('/get/territory/', type='http', auth='public', website=True)
    def territory(self, **kw):
        api = CodeWholeSaleAPI(token=token)
        response = api.raw_query(
            endpoint=f'v2/territory',
            http_method='get',
            data={}
        )
        if response.status_code in (200, 202):
            try:
                territories = ast.literal_eval(response.content.decode('utf-8'))['territories']
                for territory in territories:
                    existing_territories = len(http.request.env['cws.region'].search(
                        [('name', '=', territory['territory'])]))
                    if existing_territories:
                        continue
                    else:
                        http.request.env['cws.territory'].create({'name': territory['territory']})
            except Exception as e:
                print(e.args[0])
                return "API exception"
            return "Region created"
        else:
            return "API failed"
