# -*- coding: utf-8 -*-

import ast
import json
import base64
import urllib.request as urllib2

from odoo import http
from ..api.utils import *

token = fetch_token()


class CodeswholesaleProducts(http.Controller):

    @http.route('/get/products/', type='http', auth='public', website=True)
    def products(self, **kw):
        api = CodeWholeSaleAPI(token=token)
        response = api.raw_query(
            endpoint=f'v2/products',
            http_method='get',
            data={}
        )
        if response.status_code in (200, 202):
            try:
                i = 0
                items = json.loads(response.content.decode('utf-8'))['items']
                for item in items:
                    product_id = item['productId']
                    name = item['name']
                    identifier = item['identifier']
                    if item['prices']:
                        price = item['prices'][0]['value']
                    else:
                        price = -1
                    http.request.env['product.template'].create({
                        'product_codewholesale_id': product_id,
                        'name': name,
                        'price': price,
                        'sale_ok': True,
                        'default_code': identifier,
                        'detailed_type': 'product',
                        'active': True,
                        'image_1920': base64.encodestring(urllib2.urlopen(item['images'][0]['image']).read())

                    })
                    i += 1
                    if i > 100:
                        break
                    print("Product Created")
            except Exception as e:
                print(e.args[0])
                return "API exception"

    @http.route('/get/products/<string:productId>', type='http', auth='public', website=True)
    def productid(self, **kw):
        api = CodeWholeSaleAPI(token=token)
        product_id = kw['productId']
        endpoint = (f'v2/products/%s' % product_id)
        response = api.raw_query(
            endpoint=endpoint,
            http_method='get',
            data={}
        )
        if response.status_code in (200, 202):
            try:
                item = json.loads(response.content.decode('utf-8'))
                product_id = item['productId']
                name = item['name']
                identifier = item['identifier']
                if item['prices']:
                    price = item['prices'][0]['value']
                else:
                    price = -1
                product_template_id = http.request.env['product.template'].sudo().search([('product_codewholesale_id', '=', product_id)],limit=1)
                if not product_template_id:
                    http.request.env['product.template'].create({
                        'product_codewholesale_id': product_id,
                        'name': name,
                        'price': price,
                        'sale_ok': True,
                        'default_code': identifier,
                        'detailed_type': 'product',
                        'active': True,
                        'image_1920': base64.encodestring(urllib2.urlopen(item['images'][0]['image']).read())

                    })
                else:
                    product_template_id.update({
                        'product_codewholesale_id': product_id,
                        'name': name,
                        'price': price,
                        'sale_ok': True,
                        'default_code': identifier,
                        'detailed_type': 'product',
                        'active': True,
                        'image_1920': base64.encodestring(urllib2.urlopen(item['images'][0]['image']).read())

                    })
                print("Product Created")
            except Exception as e:
                print(e.args[0])
                return "API exception"
